﻿@using System;
@using System.Web;
@using System.Web.Helpers;
@using System.Collections.Generic;
@using WebMatrix.Data;

@* Remove this section if you are using bundling *@
@section Scripts {
    <script src="~/Scripts/jquery.validate.min.js"></script>
    <script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
}

@{
//    WebSecurity.RequireAuthenticatedUser();

    Layout = "~/_SiteLayout.cshtml";
    Page.Title = (string)(Session["username"]) + "'s Profile!";
    var email = "";
    try {
        email = Session["username"].ToString();
    } catch {
        Context.RedirectLocal("~/Account/Login");
    }
    string successMessage = "";

    // Setup validation
    Validation.RequireField("currentPassword", "We need your current password to verify.");
    Validation.RequireField("newPassword", "The new password field is required.");
    Validation.Add("confirmPassword",
        Validator.Required("The confirm new password field is required."),
        Validator.EqualsTo("newPassword", "The new password and confirmation password do not match.")
    );
    PWValidation validation = new PWValidation();

    if (IsPost) {
        AntiForgery.Validate();
        // Handle local account password operations
        var currentPassword = Request.Form["currentPassword"];
        var newPassword = Request.Form["newPassword"];
        var confirmPassword = Request.Form["confirmPassword"];

        if (!Validation.IsValid() || !validation.isValidPassword(newPassword)) {
            if(!validation.longEnough(newPassword)) {
                ModelState.AddError("password", "Niet lang genoeg!");
            }
            if(!validation.hasUppercase(newPassword)) {
                ModelState.AddError("password", "Geen hoofdletters!");
            }
            if(!validation.hasLowercase(newPassword)) {
                ModelState.AddError("password", "Geen kleine letters!");
            }
            if(!validation.hasDigit(newPassword)) {
                ModelState.AddError("password", "Geen cijfers!");
            }
            if(!validation.hasSpecialCharacter(newPassword)) {
                ModelState.AddError("password", "Geen speciale karakters!");
            }
        } else {
            // Insert a new user into the database
            var db = Database.Open("webdev");

            var salt = db.QueryValue("SELECT Salt FROM Accounts WHERE LOWER(Email) = LOWER(@0)", email);

            var enc_pass = Crypto.SHA256(newPassword + salt);
            db.Query("UPDATE Accounts SET Password = @1, passplain = @1 WHERE Email = @2", enc_pass, newPassword, email);              
                
            successMessage = "Password has succesfully been changed!";
        }
    }
}
<hgroup class="title">
    <h1>@Page.Title.</h1>
</hgroup>

@if (!successMessage.IsEmpty()) {
    <p class="message-success">
        @successMessage
    </p>
}

<p>You're logged in as <strong>@Session["username"]</strong>.</p>

<h3>Change password</h3>
<form method="post">
    @AntiForgery.GetHtml()
    @Html.ValidationSummary(excludeFieldErrors: true)

    <fieldset>
        <ol>
            <li class="current-password">
                <label for="currentPassword" @if (!ModelState.IsValidField("currentPassword")) {<text>class="error-label"</text>}>Current password</label>
                <input type="password" id="currentPassword" name="currentPassword" @Validation.For("currentPassword")/>
                @Html.ValidationMessage("currentPassword")
            </li>
            <li class="new-password">
                <label for="newPassword" @if (!ModelState.IsValidField("newPassword")) {<text>class="error-label"</text>}>New password</label>
                <input type="password" id="newPassword" name="newPassword" @Validation.For("newPassword")/>
                @Html.ValidationMessage("newPassword")
                @Html.ValidationMessage("password")
            </li>
            <li class="confirm-password">
                <label for="confirmPassword" @if (!ModelState.IsValidField("confirmPassword")) {<text>class="error-label"</text>}>Confirm new password</label>
                <input type="password" id="confirmPassword" name="confirmPassword" @Validation.For("confirmPassword")/>
                @Html.ValidationMessage("confirmPassword")
            </li>
        </ol>
        <button type="submit" name="action" value="password">Change</button>
        <p>
            Click <a href="~/Account/ForgotPassword" title="Forgot password page">here</a> if you've forgotten your password.
        </p>
    </fieldset>
</form>